# Generated by Django 4.1.7 on 2023-05-22 10:55

import ckeditor.fields
import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Attachment",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created_at",
                    models.DateTimeField(
                        auto_now_add=True,
                        help_text="The creation time, always in UTC timezone.",
                    ),
                ),
                (
                    "updated_at",
                    models.DateTimeField(
                        auto_now=True,
                        help_text="The last update time, always in UTC timezone.",
                    ),
                ),
                ("file", models.FileField(upload_to="email_attachements")),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Template",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=50, unique=True)),
                ("subject", models.CharField(max_length=200)),
                ("body", ckeditor.fields.RichTextField(blank=True, null=True)),
                (
                    "template_type",
                    models.PositiveSmallIntegerField(
                        choices=[
                            (0, "User Email Verification"),
                            (1, "Password Reset"),
                            (2, "User Welcome"),
                            (3, "Announcement"),
                            (4, "Promotional"),
                            (5, "General"),
                            (6, "Reminders"),
                        ],
                        default=5,
                    ),
                ),
                (
                    "attachments",
                    models.ManyToManyField(blank=True, to="email_service.attachment"),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Email",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created_at",
                    models.DateTimeField(
                        auto_now_add=True,
                        help_text="The creation time, always in UTC timezone.",
                    ),
                ),
                (
                    "updated_at",
                    models.DateTimeField(
                        auto_now=True,
                        help_text="The last update time, always in UTC timezone.",
                    ),
                ),
                ("subject", models.CharField(max_length=200)),
                ("body", models.TextField()),
                (
                    "recipients",
                    models.TextField(
                        help_text="emails separated by newline", null=True
                    ),
                ),
                (
                    "cc_emails",
                    models.TextField(
                        blank=True, help_text="emails separated by newline", null=True
                    ),
                ),
                ("from_user", models.EmailField(max_length=254)),
                (
                    "status",
                    models.PositiveSmallIntegerField(
                        choices=[(0, "Pending"), (1, "Error"), (2, "Sent")], default=0
                    ),
                ),
                (
                    "remarks",
                    models.TextField(
                        blank=True,
                        help_text="It will be used to store any error message while sending, or any additional remarks",
                    ),
                ),
                (
                    "priority",
                    models.PositiveSmallIntegerField(
                        choices=[(0, "Low"), (1, "High")], default=0
                    ),
                ),
                ("scheduled_at", models.DateTimeField(blank=True, null=True)),
                (
                    "attachments",
                    models.ManyToManyField(blank=True, to="email_service.attachment"),
                ),
                (
                    "template",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="email_service.template",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
    ]
